using Hotline.Share.Dtos.File;
using Hotline.Share.Dtos.FlowEngine.Workflow;
using Hotline.Share.Enums.FlowEngine;
using Hotline.Share.Enums.Order;
using XF.Utility.EnumExtensions;

namespace Hotline.Share.Dtos.Order.Detail;

public class OrderFlowTraceDto
{
    public string Id { get; set; }

    public DateTime CreationTime { get; set; }

    /// <summary>
    /// ڵ
    /// </summary>
    public string Name { get; set; }

    /// <summary>
    /// 
    /// </summary>
    public string? AssignerName { get; set; }

    /// <summary>
    /// 첿
    /// </summary>
    public string AssignOrgName { get; set; }

    /// <summary>
    /// Ӱ
    /// </summary>
    public string? AcceptorName { get; set; }

    public string? AcceptorOrgName { get; set; }

    /// <summary>
    /// Ӱʱ
    /// </summary>
    public DateTime? AcceptTime { get; set; }

    /// <summary>
    /// 
    /// </summary>

    public string? HandlerName { get; set; }

    /// <summary>
    /// ˲
    /// </summary>
    public string? HandlerOrgName { get; set; }

    /// <summary>
    /// ʱ
    /// </summary>
    public DateTime? HandleTime { get; set; }

    /// <summary>
    /// ڵʱ
    /// </summary>
    public DateTime? StepExpiredTime { get; set; }

    /// <summary>
    /// ڵ㳬״̬
    /// </summary>
    public EExpiredStatus? ExpiredStatus { get; set; }

    /// <summary>
    /// ʽ
    /// </summary>
    public EHandleMode? HandleMode { get; set; }

    public string HandleModeText => HandleMode.HasValue ? HandleMode.GetDescription() : "";

    /// <summary>
    /// 
    /// </summary>
    public ETraceStyle TraceStyle { get; set; }

    #region ̽ڵչ

    /// <summary>
    /// 
    /// </summary>
    public string? Opinion { get; set; }

    /// <summary>
    /// 
    /// </summary>
    public List<FileDto>? Files { get; set; }

    /// <summary>
    /// ע
    /// </summary>
    public string? Remark { get; set; }

    #endregion

    #region ڵչ


    /// <summary>
    /// Χ
    /// </summary>
    public bool PublishState { get; set; }

    /// <summary>
    /// 
    /// </summary>
    public string ArrangeOpinion { get; set; }

    #endregion

    #region طýڵչ


    /// <summary>
    /// ۣۣ
    /// </summary>
    public EVoiceEvaluate? VoiceEvaluate { get; set; }

    public string? VoiceEvaluateText => VoiceEvaluate.HasValue ? VoiceEvaluate.GetDescription() : "";

    /// <summary>
    /// Աۣۣ
    /// </summary>
    public ESeatEvaluate? SeatEvaluate { get; set; }
    public string? SeatEvaluateText => SeatEvaluate.HasValue ? SeatEvaluate.GetDescription() : "";

    /// <summary>
    /// ط
    /// </summary>
    public string? VisitContent { get; set; }

    public IReadOnlyList<OrderFlowVisitDetail> OrderFlowVisitDetails { get; set; }

    #endregion

}

/// <summary>
/// ϸطýڵչԪ
/// </summary>
public class OrderFlowVisitDetail
{
    /// <summary>
    /// Ű
    /// </summary>
    public string? OrgProcessingResults { get; set; }

    /// <summary>
    /// ԭ
    /// </summary>
    public List<string>? OrgNoSatisfiedReason { get; set; }

    /// <summary>
    /// Ű̬
    /// </summary>
    public string? OrgHandledAttitude { get; set; }

    /// <summary>
    /// ط
    /// </summary>
    public string? VisitContent { get; set; }
}